"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const formManager_1 = require("../formManager");
const controls_1 = require("./models/controls");
test('Create Form function - invalid form with invalid property value', () => {
    const form = formManager_1.createForm(controls_1.controls);
    expect(form).toBeTruthy();
    const formcontrols = form.controls;
    expect(formcontrols.test.error).toBeTruthy();
    expect(formcontrols.test.errorMessage).toBe('test is required');
    expect(form.valid).toBeFalsy();
});
test('Create Form function - valid form with valid property value', () => {
    controls_1.controls.test.value = 'create form test';
    const form = formManager_1.createForm(controls_1.controls);
    expect(form).toBeTruthy();
    const formcontrols = form.controls;
    expect(formcontrols.test.error).toBeFalsy();
    expect(formcontrols.test.errorMessage).toBe('');
    expect(form.valid).toBeTruthy();
});
test('Create Form function - validation with dependent controls', () => {
    const form = formManager_1.createForm(controls_1.dependenControls);
    expect(form).toBeTruthy();
    const formcontrols = form.controls;
    expect(formcontrols.control2.error).toBeTruthy();
    expect(formcontrols.control2.errorMessage).toBe('Control2 should match with control1');
    expect(form.valid).toBeFalsy();
});
test('Create Form function - non arguments', () => {
    const form = formManager_1.createForm();
    expect(form).toMatchObject({ controls: {}, valid: true });
});
