"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class FormControl {
    constructor(scope = {}, value, validators = [], touched = false) {
        this.scope = {};
        this._value = value;
        this._validators = validators;
        this._touched = touched;
        this.scope = scope;
    }
    get touched() {
        return this._touched;
    }
    get value() {
        return this._value;
    }
    get validators() {
        return this._validators;
    }
    get error() {
        for (const validator of this.validators) {
            if (!validator.validatorfunction.call(this.scope, this._value)) {
                return true;
            }
        }
        return false;
    }
    get errorMessage() {
        for (const validator of this.validators) {
            if (!validator.validatorfunction.call(this.scope, this._value)) {
                return validator.errorMessage;
            }
        }
        return '';
    }
}
exports.FormControl = FormControl;
